import{S as Ra,i as Ga,s as Ma,e as i,k as h,w as ke,t as n,M as ja,c as o,d as a,m as p,a as r,x as qe,h as l,b as f,N as Ja,G as t,g as c,y as Ae,q as Se,o as xe,B as Fe,v as La}from"../../chunks/vendor-hf-doc-builder.js";import{T as Ba}from"../../chunks/Tip-hf-doc-builder.js";import{I as ma}from"../../chunks/IconCopyLink-hf-doc-builder.js";function Ua(se){let u;return{c(){u=n("\u{1F4A1} Even though here we pretend spectrograms are the same as images, there are important differences. For example, shifting the contents of an image up or down generally does not change the meaning of what is in the image. However, shifting a spectrogram up or down will change the frequencies that are in the sound and completely change its character. Images are invariant under translation but spectrograms are not. Treating spectrograms as images can work very well in practice, but keep in mind they are not really the same thing.")},l(g){u=l(g,"\u{1F4A1} Even though here we pretend spectrograms are the same as images, there are important differences. For example, shifting the contents of an image up or down generally does not change the meaning of what is in the image. However, shifting a spectrogram up or down will change the frequencies that are in the sound and completely change its character. Images are invariant under translation but spectrograms are not. Treating spectrograms as images can work very well in practice, but keep in mind they are not really the same thing.")},m(g,m){c(g,u,m)},d(g){g&&a(u)}}}function Ka(se){let u,g,m,w,j,S,Pe,J,Ne,ie,W,Ve,oe,y,_,L,x,Ie,B,We,re,O,Oe,ne,v,De,U,He,ze,D,Re,Ge,le,T,Me,K,je,Je,ce,H,Le,fe,F,z,ga,he,P,Be,N,Ue,pe,C,ue,b,E,Q,V,Ke,X,Qe,de,$,Xe,R,Ye,Ze,me,d,ea,Y,aa,ta,Z,sa,ia,ee,oa,ra,ge,G,na,ve,k,la,ae,ca,fa,ye,q,ha,te,pa,ua,be;return S=new ma({}),x=new ma({}),C=new Ba({props:{$$slots:{default:[Ua]},$$scope:{ctx:se}}}),V=new ma({}),{c(){u=i("meta"),g=h(),m=i("h1"),w=i("a"),j=i("span"),ke(S.$$.fragment),Pe=h(),J=i("span"),Ne=n("Audio classification architectures"),ie=h(),W=i("p"),Ve=n("The goal of audio classification is to predict a class label for an audio input. The model can predict a single class label that covers the entire input sequence, or it can predict a label for every audio frame \u2014 typically every 20 milliseconds of input audio \u2014 in which case the model\u2019s output is a sequence of class label probabilities. An example of the former is detecting what bird is making a particular sound; an example of the latter is speaker diarization, where the model predicts which speaker is speaking at any given moment."),oe=h(),y=i("h2"),_=i("a"),L=i("span"),ke(x.$$.fragment),Ie=h(),B=i("span"),We=n("Classification using spectrograms"),re=h(),O=i("p"),Oe=n("One of the easiest ways to perform audio classification is to pretend it\u2019s an image classification problem!"),ne=h(),v=i("p"),De=n("Recall that a spectrogram is a two-dimensional tensor of shape "),U=i("code"),He=n("(frequencies, sequence length)"),ze=n(". In the "),D=i("a"),Re=n("chapter on audio data"),Ge=n(" we plotted these spectrograms as images. Guess what? We can literally treat the spectrogram as an image and pass it into a regular CNN classifier model such as ResNet and get very good predictions. Even better, we can use a image transformer model such as ViT."),le=h(),T=i("p"),Me=n("This is what "),K=i("strong"),je=n("Audio Spectrogram Transformer"),Je=n(" does. It uses the ViT or Vision Transformer model, and passes it spectrograms as input instead of regular images. Thanks to the transformer\u2019s self-attention layers, the model is better able to capture global context than a CNN is."),ce=h(),H=i("p"),Le=n("Just like ViT, the AST model splits the audio spectrogram into a sequence of partially overlapping image patches of 16\xD716 pixels. This sequence of patches is then projected into a sequence of embeddings, and these are given to the transformer encoder as input as usual. AST is an encoder-only transformer model and so the output is a sequence of hidden-states, one for each 16\xD716 input patch. On top of this is a simple classification layer with sigmoid activation to map the hidden-states to classification probabilities."),fe=h(),F=i("div"),z=i("img"),he=h(),P=i("p"),Be=n("Image from the paper "),N=i("a"),Ue=n("AST: Audio Spectrogram Transformer"),pe=h(),ke(C.$$.fragment),ue=h(),b=i("h2"),E=i("a"),Q=i("span"),ke(V.$$.fragment),Ke=h(),X=i("span"),Qe=n("Any transformer can be a classifier"),de=h(),$=i("p"),Xe=n("In a "),R=i("a"),Ye=n("previous section"),Ze=n(" you\u2019ve seen that CTC is an efficient technique for performing automatic speech recognition using an encoder-only transformer.  Such CTC models already are classifiers, predicting probabilities for class labels from a tokenizer vocabulary. We can take a CTC model and turn it into a general-purpose audio classifier by changing the labels and training it with a regular cross-entropy loss function instead of the special CTC loss."),me=h(),d=i("p"),ea=n("For example, HF Transformers has a "),Y=i("code"),aa=n("Wav2Vec2ForCTC"),ta=n(" model but also "),Z=i("code"),sa=n("Wav2Vec2ForSequenceClassification"),ia=n(" and "),ee=i("code"),oa=n("Wav2Vec2ForAudioFrameClassification"),ra=n(". The only differences between the architectures of these models is the size of the classification layer and the loss function used."),ge=h(),G=i("p"),na=n("In fact, any encoder-only audio transformer model can be turned into an audio classifier by adding a classification layer on top of the sequence of hidden states. (Classifiers usually don\u2019t need a transformer decoder.)"),ve=h(),k=i("p"),la=n("To predict a single classification score for the entire sequence ("),ae=i("code"),ca=n("Wav2Vec2ForSequenceClassification"),fa=n("), the model takes the mean over the hidden-states and feeds that into the classification layer. The output is a single probability distribution."),ye=h(),q=i("p"),ha=n("To make a separate classification for each audio frame ("),te=i("code"),pa=n("Wav2Vec2ForAudioFrameClassification"),ua=n("), the classifier is run on the sequence of hidden-states, and so the output of the classifier is a sequence too."),this.h()},l(e){const s=ja('[data-svelte="svelte-1phssyn"]',document.head);u=o(s,"META",{name:!0,content:!0}),s.forEach(a),g=p(e),m=o(e,"H1",{class:!0});var I=r(m);w=o(I,"A",{id:!0,class:!0,href:!0});var va=r(w);j=o(va,"SPAN",{});var ya=r(j);qe(S.$$.fragment,ya),ya.forEach(a),va.forEach(a),Pe=p(I),J=o(I,"SPAN",{});var ba=r(J);Ne=l(ba,"Audio classification architectures"),ba.forEach(a),I.forEach(a),ie=p(e),W=o(e,"P",{});var wa=r(W);Ve=l(wa,"The goal of audio classification is to predict a class label for an audio input. The model can predict a single class label that covers the entire input sequence, or it can predict a label for every audio frame \u2014 typically every 20 milliseconds of input audio \u2014 in which case the model\u2019s output is a sequence of class label probabilities. An example of the former is detecting what bird is making a particular sound; an example of the latter is speaker diarization, where the model predicts which speaker is speaking at any given moment."),wa.forEach(a),oe=p(e),y=o(e,"H2",{class:!0});var we=r(y);_=o(we,"A",{id:!0,class:!0,href:!0});var _a=r(_);L=o(_a,"SPAN",{});var Ta=r(L);qe(x.$$.fragment,Ta),Ta.forEach(a),_a.forEach(a),Ie=p(we),B=o(we,"SPAN",{});var Ca=r(B);We=l(Ca,"Classification using spectrograms"),Ca.forEach(a),we.forEach(a),re=p(e),O=o(e,"P",{});var Ea=r(O);Oe=l(Ea,"One of the easiest ways to perform audio classification is to pretend it\u2019s an image classification problem!"),Ea.forEach(a),ne=p(e),v=o(e,"P",{});var M=r(v);De=l(M,"Recall that a spectrogram is a two-dimensional tensor of shape "),U=o(M,"CODE",{});var $a=r(U);He=l($a,"(frequencies, sequence length)"),$a.forEach(a),ze=l(M,". In the "),D=o(M,"A",{href:!0});var ka=r(D);Re=l(ka,"chapter on audio data"),ka.forEach(a),Ge=l(M," we plotted these spectrograms as images. Guess what? We can literally treat the spectrogram as an image and pass it into a regular CNN classifier model such as ResNet and get very good predictions. Even better, we can use a image transformer model such as ViT."),M.forEach(a),le=p(e),T=o(e,"P",{});var _e=r(T);Me=l(_e,"This is what "),K=o(_e,"STRONG",{});var qa=r(K);je=l(qa,"Audio Spectrogram Transformer"),qa.forEach(a),Je=l(_e," does. It uses the ViT or Vision Transformer model, and passes it spectrograms as input instead of regular images. Thanks to the transformer\u2019s self-attention layers, the model is better able to capture global context than a CNN is."),_e.forEach(a),ce=p(e),H=o(e,"P",{});var Aa=r(H);Le=l(Aa,"Just like ViT, the AST model splits the audio spectrogram into a sequence of partially overlapping image patches of 16\xD716 pixels. This sequence of patches is then projected into a sequence of embeddings, and these are given to the transformer encoder as input as usual. AST is an encoder-only transformer model and so the output is a sequence of hidden-states, one for each 16\xD716 input patch. On top of this is a simple classification layer with sigmoid activation to map the hidden-states to classification probabilities."),Aa.forEach(a),fe=p(e),F=o(e,"DIV",{class:!0});var Sa=r(F);z=o(Sa,"IMG",{src:!0,alt:!0}),Sa.forEach(a),he=p(e),P=o(e,"P",{});var da=r(P);Be=l(da,"Image from the paper "),N=o(da,"A",{href:!0,rel:!0});var xa=r(N);Ue=l(xa,"AST: Audio Spectrogram Transformer"),xa.forEach(a),da.forEach(a),pe=p(e),qe(C.$$.fragment,e),ue=p(e),b=o(e,"H2",{class:!0});var Te=r(b);E=o(Te,"A",{id:!0,class:!0,href:!0});var Fa=r(E);Q=o(Fa,"SPAN",{});var Pa=r(Q);qe(V.$$.fragment,Pa),Pa.forEach(a),Fa.forEach(a),Ke=p(Te),X=o(Te,"SPAN",{});var Na=r(X);Qe=l(Na,"Any transformer can be a classifier"),Na.forEach(a),Te.forEach(a),de=p(e),$=o(e,"P",{});var Ce=r($);Xe=l(Ce,"In a "),R=o(Ce,"A",{href:!0});var Va=r(R);Ye=l(Va,"previous section"),Va.forEach(a),Ze=l(Ce," you\u2019ve seen that CTC is an efficient technique for performing automatic speech recognition using an encoder-only transformer.  Such CTC models already are classifiers, predicting probabilities for class labels from a tokenizer vocabulary. We can take a CTC model and turn it into a general-purpose audio classifier by changing the labels and training it with a regular cross-entropy loss function instead of the special CTC loss."),Ce.forEach(a),me=p(e),d=o(e,"P",{});var A=r(d);ea=l(A,"For example, HF Transformers has a "),Y=o(A,"CODE",{});var Ia=r(Y);aa=l(Ia,"Wav2Vec2ForCTC"),Ia.forEach(a),ta=l(A," model but also "),Z=o(A,"CODE",{});var Wa=r(Z);sa=l(Wa,"Wav2Vec2ForSequenceClassification"),Wa.forEach(a),ia=l(A," and "),ee=o(A,"CODE",{});var Oa=r(ee);oa=l(Oa,"Wav2Vec2ForAudioFrameClassification"),Oa.forEach(a),ra=l(A,". The only differences between the architectures of these models is the size of the classification layer and the loss function used."),A.forEach(a),ge=p(e),G=o(e,"P",{});var Da=r(G);na=l(Da,"In fact, any encoder-only audio transformer model can be turned into an audio classifier by adding a classification layer on top of the sequence of hidden states. (Classifiers usually don\u2019t need a transformer decoder.)"),Da.forEach(a),ve=p(e),k=o(e,"P",{});var Ee=r(k);la=l(Ee,"To predict a single classification score for the entire sequence ("),ae=o(Ee,"CODE",{});var Ha=r(ae);ca=l(Ha,"Wav2Vec2ForSequenceClassification"),Ha.forEach(a),fa=l(Ee,"), the model takes the mean over the hidden-states and feeds that into the classification layer. The output is a single probability distribution."),Ee.forEach(a),ye=p(e),q=o(e,"P",{});var $e=r(q);ha=l($e,"To make a separate classification for each audio frame ("),te=o($e,"CODE",{});var za=r(te);pa=l(za,"Wav2Vec2ForAudioFrameClassification"),za.forEach(a),ua=l($e,"), the classifier is run on the sequence of hidden-states, and so the output of the classifier is a sequence too."),$e.forEach(a),this.h()},h(){f(u,"name","hf:doc:metadata"),f(u,"content",JSON.stringify(Qa)),f(w,"id","audio-classification-architectures"),f(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(w,"href","#audio-classification-architectures"),f(m,"class","relative group"),f(_,"id","classification-using-spectrograms"),f(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(_,"href","#classification-using-spectrograms"),f(y,"class","relative group"),f(D,"href","../chapter1/audio_data"),Ja(z.src,ga="https://huggingface.co/datasets/huggingface-course/audio-course-images/resolve/main/ast.png")||f(z,"src",ga),f(z,"alt","The audio spectrogram transformer works on a sequence of patches taken from the spectrogram"),f(F,"class","flex justify-center"),f(N,"href","https://arxiv.org/pdf/2104.01778.pdf"),f(N,"rel","nofollow"),f(E,"id","any-transformer-can-be-a-classifier"),f(E,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(E,"href","#any-transformer-can-be-a-classifier"),f(b,"class","relative group"),f(R,"href","ctc")},m(e,s){t(document.head,u),c(e,g,s),c(e,m,s),t(m,w),t(w,j),Ae(S,j,null),t(m,Pe),t(m,J),t(J,Ne),c(e,ie,s),c(e,W,s),t(W,Ve),c(e,oe,s),c(e,y,s),t(y,_),t(_,L),Ae(x,L,null),t(y,Ie),t(y,B),t(B,We),c(e,re,s),c(e,O,s),t(O,Oe),c(e,ne,s),c(e,v,s),t(v,De),t(v,U),t(U,He),t(v,ze),t(v,D),t(D,Re),t(v,Ge),c(e,le,s),c(e,T,s),t(T,Me),t(T,K),t(K,je),t(T,Je),c(e,ce,s),c(e,H,s),t(H,Le),c(e,fe,s),c(e,F,s),t(F,z),c(e,he,s),c(e,P,s),t(P,Be),t(P,N),t(N,Ue),c(e,pe,s),Ae(C,e,s),c(e,ue,s),c(e,b,s),t(b,E),t(E,Q),Ae(V,Q,null),t(b,Ke),t(b,X),t(X,Qe),c(e,de,s),c(e,$,s),t($,Xe),t($,R),t(R,Ye),t($,Ze),c(e,me,s),c(e,d,s),t(d,ea),t(d,Y),t(Y,aa),t(d,ta),t(d,Z),t(Z,sa),t(d,ia),t(d,ee),t(ee,oa),t(d,ra),c(e,ge,s),c(e,G,s),t(G,na),c(e,ve,s),c(e,k,s),t(k,la),t(k,ae),t(ae,ca),t(k,fa),c(e,ye,s),c(e,q,s),t(q,ha),t(q,te),t(te,pa),t(q,ua),be=!0},p(e,[s]){const I={};s&2&&(I.$$scope={dirty:s,ctx:e}),C.$set(I)},i(e){be||(Se(S.$$.fragment,e),Se(x.$$.fragment,e),Se(C.$$.fragment,e),Se(V.$$.fragment,e),be=!0)},o(e){xe(S.$$.fragment,e),xe(x.$$.fragment,e),xe(C.$$.fragment,e),xe(V.$$.fragment,e),be=!1},d(e){a(u),e&&a(g),e&&a(m),Fe(S),e&&a(ie),e&&a(W),e&&a(oe),e&&a(y),Fe(x),e&&a(re),e&&a(O),e&&a(ne),e&&a(v),e&&a(le),e&&a(T),e&&a(ce),e&&a(H),e&&a(fe),e&&a(F),e&&a(he),e&&a(P),e&&a(pe),Fe(C,e),e&&a(ue),e&&a(b),Fe(V),e&&a(de),e&&a($),e&&a(me),e&&a(d),e&&a(ge),e&&a(G),e&&a(ve),e&&a(k),e&&a(ye),e&&a(q)}}}const Qa={local:"audio-classification-architectures",sections:[{local:"classification-using-spectrograms",title:"Classification using spectrograms"},{local:"any-transformer-can-be-a-classifier",title:"Any transformer can be a classifier"}],title:"Audio classification architectures"};function Xa(se){return La(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class at extends Ra{constructor(u){super();Ga(this,u,Xa,Ka,Ma,{})}}export{at as default,Qa as metadata};
